#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xjf binutils-2.23.1.tar.bz2
    cd binutils-2.23.1
    ./configure --prefix=/usr --sysconfdir=/etc --disable-werror --build="`
	    cpp -dumpmachine`"
    make configure-bfd
    make -C bfd
    make -C libiberty
    make configure-opcodes
    make -C opcodes
    make configure-binutils
    make -C binutils strip-new objdump
    strip -R .note -R .comment binutils/strip-new binutils/objdump
    mkdir -p ../strip/bin ../objdump/bin
    cp binutils/strip-new ../strip/bin/strip
    cp binutils/objdump ../objdump/bin/
    cd ..
    rm -rf binutils-2.23.1
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
